# Disable debuginfo because is make no sense for haskell staff

%define debug_package %{nil}

Name:		kaya
Version:	0.5.2
Release:	24%{?dist}
Summary:	A Statically typed, imperative programming-language

Group:		Development/Languages
License:	GPLv2+ and LGPLv2+
URL:		http://kayalang.org
Source0:	http://kayalang.org/src/%{name}-%{version}.tgz
Patch1:		kaya-0.5.2-conf.patch

# Patch from upstream
Patch2:	        kaya-0.5.2-ghc612.patch

# will be send to upstream
Patch3:		kaya-0.5.2-gc.patch
Patch4:		kaya-0.5.2-dyn.patch
Patch5:		kaya-0.5.2-codegen.patch
Patch6:		kaya-0.5.2-gcc47.patch
Patch7:		kaya-0.5.2-ghc74-base.patch
Patch8:         kaya-0.5.2-ghc76.patch

ExcludeArch:	sparc64

BuildRequires:  libtool, autoconf, pkgconfig
BuildRequires:	gc-devel, happy, zlib-devel, gnutls-devel
BuildRequires:  libgcrypt-devel, pcre-devel
BuildRequires:	postgresql-devel, mariadb-devel, sqlite-devel
BuildRequires:  gd-devel, SDL-devel, mesa-libGL-devel
BuildRequires:  ncurses-devel, freeglut-devel

BuildRequires:  ghc-array-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-editline-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-old-locale-devel
BuildRequires:  ghc-old-time-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-random-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-unix-devel

%description
Kaya is a compiled statically typed (ie, types are checked at compile time)
imperative programming language; unlike other such languages, however, types
are inferred rather than declared - there is no need for type declarations of
local variables. Kaya has "tagged union" data structures, a powerful feature 
more commonly found in functional languages such as Ocaml and Haskell.

Kaya also has built-in abstractions for web application development, making 
it easy to write a CGI program without paying too much attention to low level 
details such as state management and form handling. 

%package doc
Summary: Documentation and Samples for the Kaya Language
Group:	 Documentation
BuildArch: noarch

%description doc
This package contains the documentation for the kaya language.

Additional you may find samples for this language.

%prep
%setup -q
%patch1 -p1 -b .orig
%patch2 -p1 -b .ghc621
%patch3 -p1 -b .gc
%patch4 -p1 -b .dyn
%patch5 -p1 -b .codegen
%patch6 -p1 -b .gcc47
%patch7 -p1 -b .haskell98

%if 0%{?fedora} > 19
%patch8 -p1 -b .ghc76
%endif

%build
autoreconf
CFLAGS=$(echo $RPM_OPT_FLAGS | sed -e 's/\-wp,\-D_FORTIFY_SOURCE=2//g' | \
                               sed -e 's/\-fstack\-protector\-strong//g' )
%configure

# make doesn't support _smp_flags
make # %{?_smp_mflags} 

%install
make install DESTDIR=$RPM_BUILD_ROOT libdir=%{_libdir}/kaya

pushd $RPM_BUILD_ROOT%{_bindir}
strip kayac
strip kaya-rekey
strip kayadoc2man
popd

%check
# test063 fails due to DSOImplicitLinking ( FTBFS http://bugzilla.redhat.com/555493 )
# make non-fatal for now, just so we can get a build done, but it still needs to
# be fixed properly
make test ||:

%files
%defattr(-,root,root,-)
%{_bindir}/kaya
%{_bindir}/kayac
%{_bindir}/kaya-rekey
%{_bindir}/kayadoc2man
%{_libdir}/kaya/
%{_mandir}/man1/*

%doc COPYING GPL2 GPL3 LGPL2.1 LGPL3

%files doc
%defattr(-,root,root,-)
%{_mandir}/man3/*
%doc examples/ docs/

%changelog
* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-24
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-23
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Apr 23 2014 Tomáš Mráz <tmraz@redhat.com> - 0.5.2-22
- Rebuild for new libgcrypt

* Wed Aug 28 2013 Jochen Schmitt <Jochen herr-schmitt de> - 0.5.2-21
- Change BR from mysql-devel to mariadb-devel

* Wed Aug 28 2013 Jochen Schmitt <Jochen herr-schmitt de> - 0.5.2-20
- Rewrite ghc76 patch in a more portable way

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild
- Remove -fstack-protector-stong, Fix BZ #995626
- Use of System.Environment.lookupEnv to fix FTBFS
- hinding findfile from System.Directory to fix FTBFS

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Nov 29 2012 Jens Petersen <petersen@redhat.com> - 0.5.2-17
- fix build with ghc-7.4 using base instead of haskell98
- no longer exclude s390x
- list haskell library deps explicitly

* Mon Nov 26 2012 Jochen Schmitt <Jochen herr-schmitt de> - 0.5.2-16
- Rebuild for new release of ghc-editline
- Remove obsolete stuff from SPEC file
- Add ghc-unix-devel as a BR

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Feb 10 2012 Petr Pisar <ppisar@redhat.com> - 0.5.2-14
- Rebuild against PCRE 8.30

* Thu Jan 19 2012 Jochen Schmitt <Jochen herr-schmitt de> - 0.5.2-133
- Set ExcludeArch to the same values as ghc
- Add include to unistd.h to fix gcc-4.7 build issue
- Import Control.Exception to fix catch not in scope

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-12.2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Fri Oct 21 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.5.2-11.2
- rebuild with new gmp without compat lib

* Wed Oct 12 2011 Peter Schiffer <pschiffe@redhat.com> - 0.5.2-11.1
- rebuild with new gmp

* Thu Mar 10 2011 Fabio M. Di Nitto <fdinitto@redhat.com> - 0.5.2-11
- Enable build on sparcv9

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Feb  1 2011 Dan Horák <dan[at]danny.cz> - 0.5.2-9
- updated the supported arch list

* Wed Dec  1 2010 Jochen Schmitt <Jochen herr-schmitt de>-  0.5.2-8
- Fix for ghc-7.0.1

* Wed May  5 2010 Jochen Schmitt <Jochen herr-schmitt de> - 0.5.2-6
- Fix GC-API issue and ImplicitDSOLining failure (#555493)

* Mon May 03 2010 Rex Dieter <rdieter@fedoraproject.org> - 0.5.3-6
- New gc release breaks kaya build (#587391)
- FIXME/TODO: ImplicitDSOLinking failure in %%check test063

* Sat Mar  6 2010 Jochen Schmitt <Jochen herr-schmitt de> - 0.5.2-5
- Fix FTBFS agains ghc-6.12 (#555493)

* Wed Jul 29 2009 Jochen Schmitt <Jochen herr-schmitt de> - 0.5.2-4
- Fix wrong BR.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 22 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-2
- Bump release

* Sun Jun 28 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.2-1
- New upstream release

* Thu Mar  5 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.1-4
- Supporting noarch subpackages

* Tue Mar  3 2009 Jochen Schmitt <Jochen herr-schmitt de> 0.5.1-3
- Fix ghc-6.10 releated issues

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 0.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Aug  4 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.1-1
- New upstream release

* Mon Jun  9 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-5
- Koji don't like -fstack-protector

* Thu Jun  5 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-4
- Fix issue to detect mysql in configure script

* Sun Jun  1 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-3
- Add default attributes for doc package files
- Fix SMP issue

* Thu May 29 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-2
- Striping executables files

* Mon May 26 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.5.0-1
- New upstream relase

* Sun May  4 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-5
- Comment special handlings
- Create sub package for documentation and samples

* Mon Apr 28 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-4
- Fix some smp issues

* Mon Apr 28 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-3
- Enable parallel building

* Sun Apr 27 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-2
- disable generating of debuginfo package
- Remove unnecessary patch

* Tue Apr 15 2008 Jochen Schmitt <Jochen herr-schmitt de> 0.4.0-1
- New upstream release

* Thu Nov 29 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.7-4
- Generate debuginfos
- Fix an error in the kayac man page

* Wed Nov  7 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.7-3
- Fix build id issue

* Tue Oct 30 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.7-1
- New upstream release

* Tue Oct  9 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.6-2
- Fix wrong license tag.

* Tue Sep 11 2007 Jochen Schmitt <Jochen herr-schmitt de> 0.2.6-1
- Initial RPM

